/* Reminder.m created by wjabi on Sat 17-Jan-1998 */

#import "Reminder.h"

@implementation Reminder

-(id) init
{
    [super init];
    reminderString = @"";
    repeats = NO;
    absolute = NO;
    return self;
}

- (void) setStringValue:(NSString *)aString
{
    if(reminderString)
      {
        [reminderString autorelease];
      }
    reminderString = [aString copy];
}

- (NSString *) stringValue
{
    return reminderString;
}

- (void) setRepeats:(BOOL)repeatsValue
{
    repeats = repeatsValue;
}

- (BOOL) getRepeats
{
    return repeats;
}

- (void) setAbsolute:(BOOL)absoluteValue
{
    absolute = absoluteValue;
}

- (BOOL) getAbsolute
{
    return absolute;
}

- (id) setReminder:(int)hr :(int)min :(int)sec :aTarget :(SEL)aSelector :(BOOL)repeatsValue :(BOOL)absoluteValue :(NSString *)aString;
{
    long timeInterval, todayTimeInterval, newTimeInterval;
    NSDate *newDate, *today;
    repeats = repeatsValue;
    [self setStringValue:aString];
    if(timer)
      {
        [timer invalidate];
        [timer autorelease];
      }
    if (absoluteValue)
      {
        absolute = absoluteValue;
        hours = hr;
        minutes = min;
        seconds = sec;
        newDate = [NSDate dateWithNaturalLanguageString:[NSString stringWithFormat:@"today %02d:%02d:%02d",hr, min, sec] locale:nil];
        newTimeInterval = [newDate timeIntervalSince1970];
        today = [NSDate date];
        todayTimeInterval = [today timeIntervalSince1970];
        if (newTimeInterval < todayTimeInterval)
          {
            newTimeInterval += 12*60*60;
          }
        if (newTimeInterval < todayTimeInterval)
          {
            newTimeInterval += 12*60*60;
          }
        timeInterval = newTimeInterval - todayTimeInterval;
      }
    else
      {
        timeInterval = ConvertTimeToSeconds(hr, min, sec);
      }
    timer = [NSTimer scheduledTimerWithTimeInterval:(NSTimeInterval)timeInterval target:aTarget selector:aSelector userInfo:self repeats:(BOOL)repeats];
    [timer retain];
    return self;
}

- (void) cancelReminder
{
    if(timer)
      {
        [timer invalidate];
        [timer autorelease];
      }
}

- (BOOL) getValid
{
    if(timer)
      {
        return [timer isValid];
      }
    else
      {
        return NO;
      }
}

- (void) remainingTime:(int *)hr minutes:(int *)min seconds:(int *)sec
{
    NSDate *fireDate;
    NSTimeInterval timeInterval = 0;
    if(timer)
      {
        if([timer isValid])
          {
            fireDate = [timer fireDate];
            timeInterval = [fireDate timeIntervalSinceNow];
          }
      }
    if(absolute)
      {
        *hr = hours;
        *min = minutes;
        *sec = seconds;
        return;
      }
    else
      {
        if(timeInterval > 0)
          {
            ConvertSecondsToTime(timeInterval, hr, min, sec);
            return;
          }
        else
          {
            *hr  = 0;
            *min = 0;
            *sec = 0;
            return;
          }

      }
}

long ConvertTimeToSeconds(int hr, int min, int sec)
{
    long seconds;
    seconds = ((hr *3600) + (min * 60) + sec);
    return seconds;
}

void ConvertSecondsToTime(long totalSeconds, int *hours, int *minutes, int *secs)
{
    *hours = totalSeconds/3600;
    *minutes = ((totalSeconds%3600)/60);
    *secs = ((totalSeconds%60));
}

@end
