#import <AppKit/AppKit.h>

@interface ReminderController : NSObject
{
    id mainWindow;
    id hoursField;
    id minutesField;
    id reminderInField;
    id remindersTable;
    id secondsField;
    id hoursSlider;
    id minutesSlider;
    id secondsSlider;
    id repeatsSwitchBox;
    id absoluteSwitchBox;
    id addButton;
    id replaceButton;
    id deleteButton;
    id addMenuItem;
    id replaceMenuItem;
    id deleteMenuItem;
    id timeField;
    id mainMenu;

    NSMutableArray *reminderArray;
    BOOL repeats;
    BOOL absolute;
}
- (void)applicationDidFinishLaunching:(NSNotification *)notification;
- (int)numberOfRowsInTableView:(NSTableView *)theTableView;
- (id)tableView:(NSTableView *)theTableView objectValueForTableColumn: (NSTableColumn *)theColumn row:(int)rowIndex;
- (void)addReminder:(id)sender;
- (BOOL)addReminder:(id)sender atIndex:(int)rowIndex;
- (void)deleteReminderIdenticalTo:(id)aReminder;
- (void)deleteSelectedReminder:(id)sender;
- (void)replaceReminder:(id)sender;
- (void)setRepeats:(id)sender;
- (void)setAbsoluteOrRelative:(id)sender;
- (void)showReminderPanel:(NSTimer *)sender;
- (void)updateControls;
- (BOOL)applicationShouldTerminateAfterLastWindowClosed:(NSApplication *)theApplication;
- (BOOL)applicationShouldTerminate:(NSApplication *)sender;
- (void)reloadData;
- (void)showWindow:(id)sender;
- (void)takeIntValueFrom:(id)sender;
- (void)textDidEndEditing:(NSNotification *)aNotification;
@end
